#!/usr/bin/php
<?php

error_reporting(E_ALL);

function pick_word_containing($char, array $wordlist) {
	$possible = [];
	foreach($wordlist as $word) {
		$cpos = strpos($word, $char);
		if ($cpos !== false) {
			$possible[] = [$word, $cpos];
		}
	}
	
	shuffle($possible);
	return $possible[0];
}

function make_acrostic($target_string, array $wordlist) {
	$words = [];
	$cpos  = [];
	
	for ($i = 0, $e = strlen($target_string); $i !== $e; ++$i) {
		list($words[], $cpos[]) = pick_word_containing($target_string[$i], $wordlist);
	}
	
	$max_cpos = max($cpos);
	
	for ($i = 0, $e = count($words); $i !== $e; ++$i) {	
		
		// pad into place
		$words[$i][$cpos[$i]] = strtoupper($target_string[$i]);
		
		// capitalise
		$words[$i] = str_repeat(' ', $max_cpos - $cpos[$i]).$words[$i];
	}
	
	return $words;
}

function print_acrostic(array $words) {
	echo implode("\n", $words)."\n";
}

function main($argv) {
	if (count($argv) !== 2) {
		echo "Usage: acrostic-gen target-string wordlist\n";
		return false;
	}
	
	$wordlist = explode("\n", file_get_contents($argv[1]));
	
	print_acrostic( make_acrostic(strtolower($argv[0]), $wordlist) );
	return true;
}

return (main(array_slice($_SERVER['argv'], 1)) ? 0 : 255);
